/*
   digiblaster.library, library skeleton
   Generated with LibMaker 0.11.
*/

/****** digiblaster.library/background **************************************
*
* DESCRIPTION
*
* HISTORY
*
*****************************************************************************
*
*/

typedef char* STRPTR;
typedef const char* CONST_STRPTR;
#define STRPTR_TYPEDEF

#define __NOLIBBASE__

#include <proto/exec.h>
#include <proto/locale.h>

#include <exec/resident.h>
#include <exec/libraries.h>
#include <exec/system.h>
#include <libraries/query.h>
#include <clib/alib_protos.h>

#include <libraries/acepansion_plugin.h>

#define UNUSED __attribute__((unused))

#include "lib_version.h"
#include "library.h"

#define CATCOMP_BLOCK
#define CATCOMP_NUMBERS
#include "lib_strings.h" /* prototypes and catcomp block */



struct PluginData
{
    // Plugin generic part (do NEVER put anything before this!)
    struct ACEpansionPlugin common;

    // Digiblaster specifics
    SHORT audioSample;
};



const char LibName[] = LIBNAME;
extern const char VTag[];

struct Library *SysBase;


struct Library *LibInit(struct Library *unused, APTR seglist, struct Library *sysb);
struct MyLibBase *lib_init(struct MyLibBase *base, APTR seglist, struct Library *SysBase);
APTR lib_expunge(struct MyLibBase *base);
struct Library *LibOpen(void);
ULONG LibClose(void);
APTR LibExpunge(void);
ULONG LibReserved(void);
BOOL InitResources(struct MyLibBase *base);
VOID FreeResources(struct MyLibBase *base);
STRPTR GetString(struct MyLibBase *base, LONG id);

struct ACEpansionPlugin * LibCreatePlugin(struct MyLibBase *base, CONST_STRPTR *toolTypes, struct SignalSemaphore *sema);
VOID LibDeletePlugin(struct MyLibBase *base, struct ACEpansionPlugin *plugin);
BOOL LibActivatePlugin(struct MyLibBase *base, struct ACEpansionPlugin *plugin, BOOL status);
VOID LibReset(struct MyLibBase *base, struct ACEpansionPlugin *plugin);
VOID LibEmulate(struct MyLibBase *base, struct ACEpansionPlugin *plugin, ULONG *signals);
VOID LibWriteIO(struct MyLibBase *base, struct ACEpansionPlugin *plugin, USHORT port, UBYTE value);
VOID LibReadIO(struct MyLibBase *base, struct ACEpansionPlugin *plugin, USHORT port, UBYTE *value);
VOID LibGetAudio(struct MyLibBase *base, struct ACEpansionPlugin *plugin, SHORT *leftSample, SHORT *rightSample);
VOID LibPrinter(struct MyLibBase *base, struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy);
VOID LibCursor(struct MyLibBase *base, struct ACEpansionPlugin *plugin);
VOID LibAcknowledgeInterrupt(struct MyLibBase *base, struct ACEpansionPlugin *plugin, UBYTE *ivr);



BOOL InitResources(struct MyLibBase *base)
{
    BOOL success = FALSE;

    base->LocaleBase = OpenLibrary("locale.library", 0L);

    if(base->LocaleBase)
    {
        struct Library *LocaleBase = base->LocaleBase;

    	if((base->Locale = OpenLocale(NULL)))
        {
    		if((base->Catalog = OpenCatalogA(base->Locale, LIBNAME".catalog", TAG_DONE)))
            {
    			if(base->Catalog->cat_Version  != VERSION
                || base->Catalog->cat_Revision != REVISION)
                {
        			CloseCatalog(base->Catalog);
        			base->Catalog = NULL;
                }
            }
            success = TRUE;
    	}
    }

    return success;
}


VOID FreeResources(struct MyLibBase *base)
{
    if(base->LocaleBase)
    {
        struct Library *LocaleBase = base->LocaleBase;

        if(base->Locale)
        {
            if(base->Catalog)
            {
                CloseCatalog(base->Catalog);
                base->Catalog = NULL;
            }

            CloseLocale(base->Locale);
            base->Locale = NULL;
        }

        CloseLibrary(base->LocaleBase);
        base->LocaleBase = NULL;
    }
}

STRPTR GetString(struct MyLibBase *base, LONG id)
{
    LONG   *l;
    UWORD  *w;
    STRPTR  builtin;

	l = (LONG *)CatCompBlock;

    while(*l != id )
    {
        w = (UWORD *)((ULONG)l + 4);
        l = (LONG *)((ULONG)l + (ULONG)*w + 6);
    }
    builtin = (STRPTR)((ULONG)l + 6);

    if(base->Catalog)
    {
        struct Library *LocaleBase = base->LocaleBase;

        return GetCatalogStr(base->Catalog, id, builtin);
    }
    return builtin;
}

const struct TagItem RTags[] =
{
	{ QUERYINFOATTR_NAME, (IPTR)LibName },
	{ QUERYINFOATTR_IDSTRING, (IPTR)&VTag[1] },
	{ QUERYINFOATTR_COPYRIGHT, (IPTR)" 2015 Philippe Rimauro" },
	{ QUERYINFOATTR_DATE, (IPTR)DATE },
	{ QUERYINFOATTR_VERSION, VERSION },
	{ QUERYINFOATTR_REVISION, REVISION },
	{ QUERYINFOATTR_SUBTYPE, QUERYSUBTYPE_LIBRARY },
	{ TAG_END,  0 }
};

struct Resident ROMTag =
{
	RTC_MATCHWORD,
	&ROMTag,
	&ROMTag + 1,
	RTF_EXTENDED | RTF_PPC,
	VERSION,
	NT_LIBRARY,
	0,
	(char*)LibName,
	VSTRING,
	(APTR)LibInit,
	REVISION,
	(struct TagItem*)RTags
};


APTR JumpTable[] =
{
	(APTR)FUNCARRAY_BEGIN,
	(APTR)FUNCARRAY_32BIT_NATIVE,
	(APTR)LibOpen,
	(APTR)LibClose,
	(APTR)LibExpunge,
	(APTR)LibReserved,
	(APTR)0xFFFFFFFF,
	(APTR)FUNCARRAY_32BIT_SYSTEMV,
	(APTR)LibCreatePlugin,
	(APTR)LibDeletePlugin,
	(APTR)LibActivatePlugin,
	(APTR)LibReset,
	(APTR)LibEmulate,
	(APTR)LibWriteIO,
	(APTR)LibReadIO,
	(APTR)LibGetAudio,
	(APTR)LibPrinter,
	(APTR)LibCursor,
	(APTR)LibAcknowledgeInterrupt,
	(APTR)0xFFFFFFFF,
	(APTR)FUNCARRAY_END
};


struct MyLibBase * lib_init(struct MyLibBase *base, APTR seglist, UNUSED struct Library *sysbase)
{
	InitSemaphore(&base->BaseLock);
	base->Seglist = seglist;
	return base;
}

struct TagItem LibTags[] = {
	{ LIBTAG_FUNCTIONINIT, (IPTR)JumpTable },
	{ LIBTAG_LIBRARYINIT,  (IPTR)lib_init },
	{ LIBTAG_MACHINE,      MACHINE_PPC },
	{ LIBTAG_BASESIZE,     sizeof(struct MyLibBase) },
	{ LIBTAG_SEGLIST,      0 },
	{ LIBTAG_TYPE,         NT_LIBRARY },
	{ LIBTAG_NAME,         0 },
	{ LIBTAG_IDSTRING,     0 },
	{ LIBTAG_FLAGS,        LIBF_CHANGED | LIBF_SUMUSED },
	{ LIBTAG_VERSION,      VERSION },
	{ LIBTAG_REVISION,     REVISION },
	{ LIBTAG_PUBLIC,       TRUE },
	{ TAG_END,             0 },
};

struct Library * LibInit(UNUSED struct Library *unused, APTR seglist, struct Library *sysbase)
{
	SysBase = sysbase;

	LibTags[4].ti_Data = (IPTR)seglist;
	LibTags[6].ti_Data = (IPTR)ROMTag.rt_Name;
	LibTags[7].ti_Data = (IPTR)ROMTag.rt_IdString;

	return (NewCreateLibrary(LibTags));
}


struct Library * LibOpen(void)
{
	struct MyLibBase *base = (struct MyLibBase*)REG_A6;
	struct Library *lib = (struct Library*)base;

	ObtainSemaphore(&base->BaseLock);

	if (!base->InitFlag)
	{
		if (InitResources(base)) base->InitFlag = TRUE;
		else
		{
			FreeResources(base);
			lib = NULL;
		}
	}

	if (lib)
	{
		base->LibNode.lib_Flags &= ~LIBF_DELEXP;
		base->LibNode.lib_OpenCnt++;
	}

	ReleaseSemaphore(&base->BaseLock);
	if (!lib) lib_expunge(base);
	return lib;
}


ULONG LibClose(void)
{
	struct MyLibBase *base = (struct MyLibBase*)REG_A6;
	ULONG ret = 0;

	ObtainSemaphore(&base->BaseLock);

	if (--base->LibNode.lib_OpenCnt == 0)
	{
		if (base->LibNode.lib_Flags & LIBF_DELEXP) ret = (ULONG)lib_expunge(base);
	}

	if (ret == 0) ReleaseSemaphore(&base->BaseLock);
	return ret;
}


APTR LibExpunge(void)
{
	struct MyLibBase *base = (struct MyLibBase*)REG_A6;

	return(lib_expunge(base));
}


APTR lib_expunge(struct MyLibBase *base)
{
	APTR seglist = NULL;

	ObtainSemaphore(&base->BaseLock);

	if (base->LibNode.lib_OpenCnt == 0)
	{
		FreeResources(base);
		Forbid();
		Remove((struct Node*)base);
		Permit();
		seglist = base->Seglist;
		FreeMem((UBYTE*)base - base->LibNode.lib_NegSize, base->LibNode.lib_NegSize + base->LibNode.lib_PosSize);
		base = NULL;    /* freed memory, no more valid */
	}
	else base->LibNode.lib_Flags |= LIBF_DELEXP;

	if (base) ReleaseSemaphore(&base->BaseLock);
	return seglist;
}


ULONG LibReserved(void)
{
	return 0;
}



/****** digiblaster.library/CreatePlugin ************************************
*
* NAME
*   CreatePlugin -- {short} (V1)
*
* SYNOPSIS
*   struct ACEpansionPlugin * CreatePlugin(CONST_STRPTR *toolTypes, struct SignalSemaphore *sema)
*
* FUNCTION
*   Create the plugin data structure and configure how it will be handled by
*   ACE. This function is usually called at ACE startup.
*
* INPUTS
*   *toolType
*     A pointer to a NULL terminated array of CONST_STRPTR containing the
*     tooltypes provided with the plugin library.
*     The ACTIVE tooltype is handled internally by ACE for all plugins, but
*     you can here handle additional tooltypes to configure your plugin.
*   *sema
*     Pointer to a semaphore to use to protect access to custom data from
*     ACEpansionPlugin when accessed from subtasks or within your PrefsWindow.
*
* RESULT
*     A pointer to an allocated and initialized plugin data structure.
*
* SEE ALSO
*   DeletePlugin
*   ActivatePlugin
*
*****************************************************************************
*
*/

struct ACEpansionPlugin * LibCreatePlugin(UNUSED struct MyLibBase *base, UNUSED CONST_STRPTR *toolTypes, UNUSED struct SignalSemaphore *sema)
{
    // We are allocating an extended plugin structure to add our custom stuff
    struct PluginData *plugin = AllocVec(sizeof(struct PluginData), MEMF_PUBLIC|MEMF_CLEAR);

    if(plugin)
    {
        // Initialize plugin generic part
        plugin->common.ap_APIVersion     = 1;
        plugin->common.ap_Flags          = ACE_FLAGSF_EXCLUSIVE_PRINTER // We must be the only active plugin to use printer port at once
                                         | ACE_FLAGSF_ACTIVE_AUDIO      // We need the audio API
                                         | ACE_FLAGSF_ACTIVE_PRINTER;   // We need the printer API
        plugin->common.ap_Title          = GetString(base,MSG_TITLE);
        plugin->common.ap_HelpFileName   = LIBNAME".guide";
        plugin->common.ap_ToggleMenuName = GetString(base,MSG_MENU_TOGGLE);
        plugin->common.ap_PrefsMenuName  = NULL;
        plugin->common.ap_PrefsWindow    = NULL;

        // Initialize plugin specifics
        plugin->audioSample = 0;
    }

    return (struct ACEpansionPlugin *)plugin;
}



/****** digiblaster.library/DeletePlugin ************************************
*
* NAME
*   DeletePlugin -- {short} (V1)
*
* SYNOPSIS
*   VOID DeletePlugin(struct ACEpansionPlugin *plugin)
*
* FUNCTION
*   Delete a plugin data structure. This function is usually called when ACE
*   is exiting.
*
* INPUTS
*   *plugin
*     Pointer to the plugin data structure to delete.
*
* RESULT
*
* SEE ALSO
*   CreatePlugin
*   ActivatePlugin
*
*****************************************************************************
*
*/

VOID LibDeletePlugin(UNUSED struct MyLibBase *base, struct ACEpansionPlugin *plugin)
{
    FreeVec(plugin);
}



/****** digiblaster.library/ActivatePlugin **********************************
*
* NAME
*   ActivatePlugin -- {short} (V1)
*
* SYNOPSIS
*   BOOL ActivatePlugin(struct ACEpansionPlugin *plugin, BOOL status)
*
* FUNCTION
*   This function is called everytime ACE wants to activate or disactivate your plugin.
*   While you are disactivated, no other function (except Delete) will the called by ACE.
*   Please note that a plugin is always disactivated by ACE prior to DeletePlugin().
*
* INPUTS
*   status
*     New activation status requested by ACE.
*
* RESULT
*   Actual activation status (you may fail at activation for some reason, but you
*   should never fail at disactivation request).
*
* SEE ALSO
*   CreatePlugin
*   DeletePlugin
*
*****************************************************************************
*
*/

BOOL LibActivatePlugin(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, BOOL status)
{
    return status;
}



/****** digiblaster.library/Reset *******************************************
*
* NAME
*   Reset -- {short} (V1)
*
* SYNOPSIS
*   VOID Reset(struct ACEpansionPlugin *plugin)
*
* FUNCTION
*   Function that is called everytime ACE is issuing a bus reset.
*
* INPUTS
*   *plugin
*     Pointer to the plugin data structure to use.
*
* RESULT
*
* SEE ALSO
*   Emulate
*
*****************************************************************************
*
*/

VOID LibReset(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin)
{
}



/****** digiblaster.library/Emulate *****************************************
*
* NAME
*   Emulate -- {short} (V1)
*
* SYNOPSIS
*   VOID Emulate(struct ACEpansionPlugin *plugin, ULONG *signals)
*
* FUNCTION
*   Function that is called at each microsecond of the emulation step inside ACE.
*   Note: Implement this function only if is it really required for your plugin because it
*   is obviously CPU intensive.
*
* INPUTS
*   *plugin
*     Pointer to the plugin data structure to use.
*   *signals
*     Pointer to the I/O signals from the expansion port you can use or alter depending
*     on what you are emulating.
*     The signals bits can be decoded using the following flags:
*       ACE_SIGNALF_INT
*
* RESULT
*
* SEE ALSO
*   Reset
*
*****************************************************************************
*
*/

VOID LibEmulate(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED ULONG *signals)
{
}



/****** digiblaster.library/WriteIO *****************************************
*
* NAME
*   WriteIO -- {short} (V1)
*
* SYNOPSIS
*   VOID WriteIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE value)
*
* FUNCTION
*   Function that is called everytime Z80 is performing a I/O port write operation.
*   Note: Implement this function only if is it really required for your plugin because it
*   is obviously CPU intensive.
*
* INPUTS
*   port
*     Z80 port on with the I/O write operation was issued.
*   value
*     Value that was issued on the port.
*
* RESULT
*
* SEE ALSO
*   ReadIO
*
*****************************************************************************
*
*/

VOID LibWriteIO(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED USHORT port, UNUSED UBYTE value)
{
}



/****** digiblaster.library/ReadIO ******************************************
*
* NAME
*   ReadIO -- {short} (V1)
*
* SYNOPSIS
*   VOID ReadIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE *value)
*
* FUNCTION
*   Function that is called everytime Z80 is performing a I/O port read operation.
*   Note: Implement this function only if is it really required for your plugin because it
*   is obviously CPU intensive.
*
* INPUTS
*   port
*     Z80 port on with the I/O read operation was issued.
*   *value
*     Value to be returned.
*
* RESULT
*
* SEE ALSO
*   WriteIO
*
*****************************************************************************
*
*/

VOID LibReadIO(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED USHORT port, UNUSED UBYTE *value)
{
}



/****** digiblaster.library/GetAudioSample **********************************
*
* NAME
*   GetAudioSample -- {short} (V1)
*
* SYNOPSIS
*   VOID GetAudio(struct ACEpansionPlugin *plugin, SHORT *leftSample, SHORT *rightSample)
*
* FUNCTION
*   Function to be used when your plugin needs to mix an audio output with the one
*   from ACE.
*   It is called at each PSG emulation step, which means at 125KHz.
*
* INPUTS
*   *leftSample
*     Pointer to store the left audio sample to be mixed with ACE audio.
*   *rightSample
*     Pointer to store the right audio sample to be mixed with ACE audio.
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibGetAudio(UNUSED struct MyLibBase *base, struct ACEpansionPlugin *plugin, SHORT *leftSample, SHORT *rightSample)
{
    *leftSample = *rightSample = ((struct PluginData *)plugin)->audioSample;
}



/****** digiblaster.library/Printer *****************************************
*
* NAME
*   Printer -- {short} (V1)
*
* SYNOPSIS
*   VOID WritePrinter(struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy)
*
* FUNCTION
*   Function that is called everytime the CPC is accessing the printer port.
*
* INPUTS
*   data
*     8 bits written value (note that CPC is limited to 7 bits values, only Amstrad Plus
*     can actually provide the 8th bit).
*   strobe
*     Status of the /STROBE signal from the printer port.
*   *busy
*     Busy signal value that can be altered.
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibPrinter(UNUSED struct MyLibBase *base, struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, UNUSED BOOL *busy)
{
    ((struct PluginData *)plugin)->audioSample = (((data & 0x7f) | (strobe ? 0x80 : 0x00))-128) * 256;
}



/****** digiblaster.library/Cursor ******************************************
*
* NAME
*   Cursor -- {short} (V1)
*
* SYNOPSIS
*   VOID Cursor(struct ACEpansionPlugin *plugin)
*
* FUNCTION
*
* INPUTS
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibCursor(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin)
{
}



/****** digiblaster.library/AcknowledgeInterrupt ****************************
*
* NAME
*   AcknowledgeInterrupt -- {short} (V1)
*
* SYNOPSIS
*   VOID AcknowledgeInterrupt(struct ACEpansionPlugin *plugin, UBYTE *ivr)
*
* FUNCTION
*
* INPUTS
*
* RESULT
*
* SEE ALSO
*
*****************************************************************************
*
*/

VOID LibAcknowledgeInterrupt(UNUSED struct MyLibBase *base, UNUSED struct ACEpansionPlugin *plugin, UNUSED UBYTE *ivr)
{
}

